Exercise3/Exercise3/Models/ErrorViewModel.cs
using System;

namespace Exercise3.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

Exercise3/Exercise3/Models/Grade.cs
using System.ComponentModel.DataAnnotations;

namespace Exercise3.Models
{
    public class Grade
    {
        [Key]
        public int Id { get; set; }
        [Required]
        public string Name { get; set; }
        [Required]
        public int Num { get; set; }
    }
}

Exercise3/Exercise3/Models/SchoolContext.cs
using Microsoft.EntityFrameworkCore;

namespace Exercise3.Models
{
    public class SchoolContext : DbContext
    {
        public SchoolContext(DbContextOptions<SchoolContext> options) : base(options)
        {
            
        }
        public DbSet<Grade> Grades { get; set; }
        public DbSet<Student> Students { get; set; }
    }
}

Exercise3/Exercise3/Models/Student.cs
using System.ComponentModel.DataAnnotations;

namespace Exercise3.Models
{
    public class Student
    {
        [Key]
        public int Id { get; set; }
        [Required]
        public string Name { get; set; }
        [Required]
        public int Age { get; set; }
    }
}

Exercise3/Exercise3/Controllers/GradeController.cs
using Exercise3.Models;
using Exercise3.Service.GradeService;
using Microsoft.AspNetCore.Mvc;
using Microsoft.CodeAnalysis;

namespace Exercise3.Controllers
{
    public class GradeController : Controller
    {
        private readonly IGradeService _gradeService;

        public GradeController(IGradeService gradeService)
        {
            _gradeService = gradeService;
        }
        // GET
        [HttpGet]
        public IActionResult Index()
        {
            return View(_gradeService.GetAll());
        }

        [HttpGet]
        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Create(Grade grade)
        {
            _gradeService.Create(grade);
            _gradeService.Save();
            return RedirectToAction("Index");
        }

        [HttpGet]
        public IActionResult Update(int id)
        {
            var getId = _gradeService.GetById(id);
            return View(getId);
        }

        [HttpPost]
        public IActionResult Update(Grade grade)
        {
            _gradeService.Update(grade);
            _gradeService.Save();
            return RedirectToAction("Index");
        }

        [HttpGet]
        public IActionResult Delete(int id)
        {
            _gradeService.Delete(id);
            _gradeService.Save();
            return RedirectToAction("Index");
        }
    }
}

Exercise3/Exercise3/Controllers/HomeController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Exercise3.Models;

namespace Exercise3.Controllers
{
    public class HomeController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel {RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier});
        }
    }
}

Exercise3/Exercise3/Controllers/StudentController.cs
using Exercise3.Models;
using Exercise3.Service.StudentService;
using Exercise3.UnitOfWork;
using Microsoft.AspNetCore.Mvc;

namespace Exercise3.Controllers
{
    public class StudentController : Controller
    {
        private IStudentService _studentService;

        public StudentController(IStudentService studentService)
        {
            _studentService = studentService;
        }

        [HttpGet]
        public IActionResult Index()
        {
            return View(_studentService.GetAll());
        }
        // GET
        [HttpGet]
        public IActionResult Create()
        {
            return View();
        }
        [HttpPost]
        public IActionResult Create(Student student)
        {
            _studentService.Create(student);
            _studentService.Save();
            return RedirectToAction("Index");
        }

        [HttpGet]
        public IActionResult Update(int id)
        {
            var getId = _studentService.GetById(id);
            return View(getId);
        }

        [HttpPost]
        public IActionResult Update(Student student)
        {
            _studentService.Update(student);
            _studentService.Save();
            return RedirectToAction("Index");
        }

        [HttpGet]
        public IActionResult Delete(int id)
        {
            _studentService.Delete(id);
            _studentService.Save();
            return RedirectToAction("Index");
        }
    }
}

Exercise3/Exercise3/Views/Grade/Create.cshtml
@model Grade
@{
    ViewBag.Title = "title";
    Layout = "_Layout";
}
<div class="container-fluid">
    <div class="row">
        <div class="col-xl-12">
            <div>
                <h2 class="text-center">Create Class</h2>
            </div>
            <form asp-action="Create">
                <div asp-validation-summary="ModelOnly" class="text-danger"></div>
                <div class="form-group">
                    <label asp-for="Name" class="control-label"></label>
                    <input asp-for="Name" class="form-control"/>
                    <span asp-validation-for="Name" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <label asp-for="Num" class="control-label"></label>
                    <input asp-for="Num" class="form-control"/>
                    <span asp-validation-for="Num" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <input type="submit" value="Create" class="btn btn-primary"/>
                    <a class="text-dark btn btn-primary" asp-area="" asp-controller="Grade" asp-action="Index">Back</a>
                </div>
            </form>
        </div>
    </div>
</div>

Exercise3/Exercise3/Views/Grade/Index.cshtml
@model IEnumerable<Grade>
@{
    ViewBag.Title = "title";
    Layout = "_Layout";
}
<div class="m-auto">
    <div class="container">
        <div class="row">
            <div class="col-xl-12">
                <div class="shadow-lg p-3 mb-5 bg rounded">
                    <div>
                        <h2 class="text-center">List Of Class</h2>
                    </div>
                    <div class="container">
                        <table class="table table-striped">
                            <thead>
                            <tr>
                                <th scope="col">#</th>
                                <th scope="col">Class Name</th>
                                <th scope="col">Class Number</th>
                                <th scope="col"></th>
                            </tr>
                            </thead>
                            <tbody>
                            @foreach (var item in Model)
                            {
                                <tr class="text-left">
                                    <td> @Html.DisplayFor(modelItem => item.Id)</td>
                                    <td> @Html.DisplayFor(modelItem => item.Name)</td>
                                    <td> @Html.DisplayFor(modelItem => item.Num)</td>
                                    <td>
                                        <a class="btn btn-primary" asp-action="Update" asp-route-id="@item.Id">Edit</a>
                                        <a class="btn btn-primary" asp-action="Delete" asp-route-id="@item.Id">Delete</a>
                                    </td>
                                </tr>
                            }
                            </tbody>
                        </table>
                    </div>
                    <a asp-action="Create" class="btn btn-primary">Create New Class</a>
                </div>
            </div>
        </div>
    </div>
</div>

Exercise3/Exercise3/Views/Grade/Update.cshtml
@model Grade
@{
    ViewBag.Title = "title";
    Layout = "_Layout";
}
<div class="container-fluid">
    <div class="row">
        <div class="col-xl-12">
            <div>
                <h2 class="text-center">Edit Class</h2>
            </div>
            <form method="post" asp-controller="Grade" asp-action="Update">
                <input type="hidden" class="form-control" asp-for="Id">
                <div class="form-group">
                    <label asp-for="Name" class="control-label"></label>
                    <input asp-for="Name" class="form-control"/>
                    <span asp-validation-for="Name" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <label asp-for="Num" class="control-label"></label>
                    <input asp-for="Num" class="form-control"/>
                    <span asp-validation-for="Num" class="text-danger"></span>
                </div>
                <input class="btn btn-primary" type="submit" value="Save"/>
                <a class=" text-dark btn btn-primary" asp-area="" asp-controller="Grade" asp-action="Index">Back</a>
            </form>
        </div>
    </div>
    
</div>

Exercise3/Exercise3/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

Exercise3/Exercise3/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - Exercise3</title>

    <environment include="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
              asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute"
              crossorigin="anonymous"
              integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T"/>
    </environment>
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">Exercise3</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Trang chủ</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Bảo mật</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Student" asp-action="Index">Student</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Grade" asp-action="Index">Class</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <partial name="_CookieConsentPartial" />
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2019 - Exercise3 - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>

    <environment include="Development">
        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.js"></script>
    </environment>
    <environment exclude="Development">
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery"
                crossorigin="anonymous"
                integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8=">
        </script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
                crossorigin="anonymous"
                integrity="sha384-xrRywqdh3PHs8keKZN+8zzc5TX0GRTLCcmivcbNJWm2rs5C8PRhcEn3czEjhAO9o">
        </script>
    </environment>
    <script src="~/js/site.js" asp-append-version="true"></script>

    @RenderSection("Scripts", required: false)
</body>
</html>

Exercise3/Exercise3/Views/Student/Create.cshtml
@model Student
@{
    ViewBag.Title = "title";
    Layout = "_Layout";
}
<div class="container-fluid">
    <div class="row">
        <div class="col-xl-12">
            <div>
                <h2 class="text-center">Create Class</h2>
            </div>
            <form asp-action="Create">
                <div asp-validation-summary="ModelOnly" class="text-danger"></div>
                <div class="form-group">
                    <label asp-for="Name" class="control-label"></label>
                    <input asp-for="Name" class="form-control"/>
                    <span asp-validation-for="Name" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <label asp-for="Age" class="control-label"></label>
                    <input asp-for="Age" class="form-control"/>
                    <span asp-validation-for="Age" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <input type="submit" value="Create" class="btn btn-primary"/>
                    <a class="text-dark btn btn-primary" asp-area="" asp-controller="Student" asp-action="Index">Back</a>
                </div>
            </form>
        </div>
    </div>
</div>

Exercise3/Exercise3/Views/Student/Index.cshtml
@model IEnumerable<Student>
@{
    ViewBag.Title = "title";
    Layout = "_Layout";
}
<div class="m-auto">
    <div class="container">
        <div class="row">
            <div class="col-xl-12">
                <div class="shadow-lg p-3 mb-5 bg rounded">
                    <div>
                        <h2 class="text-center">List Of Student</h2>
                    </div>
                    <div class="container">
                        <table class="table table-striped">
                            <thead>
                            <tr>
                                <th scope="col">#</th>
                                <th scope="col">Student Name</th>
                                <th scope="col">Student Age</th>
                                <th scope="col"></th>
                            </tr>
                            </thead>
                            <tbody>
                            @foreach (var item in Model)
                            {
                                <tr class="text-left">
                                    <td> @Html.DisplayFor(modelItem => item.Id)</td>
                                    <td> @Html.DisplayFor(modelItem => item.Name)</td>
                                    <td> @Html.DisplayFor(modelItem => item.Age)</td>
                                    <td>
                                        <a class="btn btn-primary" asp-action="Update" asp-route-id="@item.Id">Edit</a>
                                        <a class="btn btn-primary" asp-action="Delete" asp-route-id="@item.Id">Delete</a>
                                    </td>
                                </tr>
                            }
                            </tbody>
                        </table>
                    </div>
                    <a asp-action="Create" class="btn btn-primary">Create New Class</a>
                </div>
            </div>
        </div>
    </div>
</div>

Exercise3/Exercise3/Views/Student/Update.cshtml
@model Student
@{
    ViewBag.Title = "title";
    Layout = "_Layout";
}
<div class="container-fluid">
    <div class="row">
        <div class="col-xl-12">
            <div>
                <h2 class="text-center">Edit Student</h2>
            </div>
            <form method="post" asp-controller="Student" asp-action="Update">
                <input type="hidden" class="form-control" asp-for="Id">
                <div class="form-group">
                    <label asp-for="Name" class="control-label"></label>
                    <input asp-for="Name" class="form-control"/>
                    <span asp-validation-for="Name" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <label asp-for="Age" class="control-label"></label>
                    <input asp-for="Age" class="form-control"/>
                    <span asp-validation-for="Age" class="text-danger"></span>
                </div>
                <input class="btn btn-primary" type="submit" value="Save"/>
                <a class=" text-dark btn btn-primary" asp-area="" asp-controller="Student" asp-action="Index">Back</a>
            </form>
        </div>
    </div>
    
</div>